#![cfg_attr(not(feature = "std"), no_std)]

#[cfg(any(test, feature = "std", feature = "alloc"))]
extern crate alloc;

#[cfg(any(test, feature = "std"))]
extern crate std;

pub mod cachepadded;
pub mod drop_guard;
pub mod ptr;
#[cfg(feature = "alloc")]
pub mod smallbox;

pub const fn can_transmute<A, B>() -> bool {
    use core::mem::{align_of, size_of};
    // We can transmute `A` to `B` iff `A` and `B` have the same size and the
    // alignment of `A` is greater than or equal to the alignment of `B`.
    size_of::<A>() <= size_of::<B>() && align_of::<A>() >= align_of::<B>()
}
